
function ChooseFolder() {
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a File", nsIFilePicker.modeOpen);
	var res=fp.show();
	if (res==nsIFilePicker.returnOK){
	  var thefile=fp.file;
	  // --- do something with the file here ---
	}
}

var g_Initialized = false;

var gPackageManager = null;
var gLog = null;

function InitializePackageManager() {
	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead UniversalBrowserWrite UniversalXPConnect");
	if ( gPackageManager == null ) {
		gPackageManager = Components.classes["@micromuse.com/NCIPackageManager;1"].getService(Components.interfaces.nsINCIPackageManager);
		if (gPackageManager == null ) {
			dump("Error loading object.\n" );
		} else {
		
			/// Read the command line interface
			var cmdLine = Components.classes["@mozilla.org/appshell/commandLineService;1"].getService(Components.interfaces.nsICmdLineService);
			
			/// Get the error level requisted
			gLog = Components.classes["@micromuse.com/NCILog;1"].getService(Components.interfaces.nsINCILog);
			var errorlevel = cmdLine.getCmdLineValue("-errorlevel");
			if ( errorlevel == "debug" ) {
				gLog.level=3;
			} else if ( errorlevel == "warning" ) {
				gLog.level=1;
			} else if ( errorlevel == "info" ) {
				gLog.level=2;
			} else if ( errorlevel == "error" ) {
				gLog.level=0;
			} else {
				gLog.level=gLog.level;
			}
			
			
			var text = cmdLine.getCmdLineValue("-install");
			
			if ( text == "" ) {
				text = cmdLine.getCmdLineValue("/install");
			}
			gPackageManager.productXML = text;
			
			params = cmdLine.getCmdLineValue("-params");
			if ( params != "" ) {
				gPackageManager.paramXML = params ;	
			}
			
			
		
			gPackageManager.Initialize();
		}
	}
}

function GetPackageManager() {
	return gPackageManager;
}

function InitWindow() {

	/* Initialize the dump console context...		
	*/

	if ( ! g_Initialized ) {

		try {
/*			
			var profServ = Components.classes["@mozilla.org/profile/manager;1"].getService(Components.interfaces.nsIProfile);
			dump( profServ.currentProfile + "\n" );
			if ( !profServ.profileExists( "ncisetup" )) {
				profServ.createNewProfile("ncisetup" , null , null , false );		
			}			
			profServ.currentProfile = "ncisetup";
*/

			var Pref = new Components.Constructor( "@mozilla.org/preferences;1" , "nsIPref" );
			var pref = new Pref();
			
//			var pref= Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
			pref.SetBoolPref( "browser.dom.window.dump.enabled" , true );			
			pref.SetCharPref( "capability.principal.codebase.p12.granted" , "UniversalXPConnect UniversalBrowserWrite UniversalBrowserRead");
			pref.SetCharPref( "capability.principal.codebase.p12.id" , "file://");			

			// pref.SetCharPref( "general.useragent.locale" , "fr-FR");			

		}
		catch (e) {
		}

		centerWindowOnScreen();
		g_Initialized = true ;

	
		// Install the listener for the buttons
		document.getElementById("btnNext").addEventListener("command" , OnMoveNext , false );
		document.getElementById("btnBack").addEventListener("command" , OnMoveBack , false );
		document.getElementById("btnCancel").addEventListener("command" , OnCancel , false );

	}
}


function GetCurrentPage() {

	return document.getElementById("frmMain").contentDocument.getElementById("page");
}


function GetCurrentPageTitle() {

	return GetCurrentPage().getAttribute("title");
}


var g_PassedInitialized = false;

var g_error_result = 0;
function OnMoveError( e_result ) {	
	g_error_result = e_result;
	document.getElementById("frmMain").setAttribute("src", "chrome://ncisetup/content/fatal_error.xul" );
}





/* g_Wizard = "back"|"next" function of if the wizard is
	moving forward or backward 
*/
var g_Wizard = "next";
var g_InSkipMode = false;


/*  Skip the current dialog
	uses the g_Wizard variable to detect whch way we are going.
*/
function SkipDialog() {

	g_InSkipMode = true;
	
	if ( g_Wizard == "next") {
		OnMoveNext();
	} else { // g_Wizard = "back"
		OnMoveBack();
	}
	g_InSkipMode = false;
	
}



function OnMoveNext() {

	var currentPage = GetCurrentPageTitle();
	var baseUrl = "chrome://ncisetup/content/"
	var nextUrl = "";
	var bAllow = true;
	g_Wizard = "next";
	
	if ( !g_InSkipMode ) {
		bAllow = document.getElementById("frmMain").contentWindow.CanMoveNext();
	}
	
	if ( bAllow ) {		
	
		if ( g_PassedInitialized ) {
			var next;
			next = gPackageManager.pages.getNext( currentPage );
			if ( next ) {				
			
				var pref= Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
				pref.SetCharPref( "capability.principal.codebase.p13.granted" , "UniversalXPConnect UniversalBrowserWrite UniversalBrowserRead");
				pref.SetCharPref( "capability.principal.codebase.p13.id" , next.url);			
			
			
				document.getElementById("frmMain").setAttribute("src", next.url );
			}
		
		} else {
	
	
			if ( currentPage == "Debugging" ) {
				nextUrl = baseUrl + "Initializing.xul";
			}

			if ( currentPage == "Initializing" ) {
				var next;
				next = gPackageManager.pages.item( 0 );
				if ( next ) {				

					var pref= Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
					pref.SetCharPref( "capability.principal.codebase.p13.granted" , "UniversalXPConnect UniversalBrowserWrite UniversalBrowserRead");
					pref.SetCharPref( "capability.principal.codebase.p13.id" , next.url);			

					document.getElementById("frmMain").setAttribute("src", next.url );
				}
				g_PassedInitialized = true;
			}
		}
	}
}

function OnMoveBack() {

	var currentPage = GetCurrentPageTitle();
	var baseUrl = "chrome://ncisetup/content/"
	var backUrl = "";
	g_Wizard = "back";
	
	var bAllow = true;
	
	if ( !g_InSkipMode ) {
		bAllow = document.getElementById("frmMain").contentWindow.CanMoveBack();
	}

	if ( bAllow ) {		

		if ( g_PassedInitialized ) {
			var prev;
			prev = gPackageManager.pages.getPrev( currentPage );
			if ( prev ) {				
			
				/** Force the security level */
//			var Pref = new Components.Constructor( "@mozilla.org/preferences;1" , "nsIPref" );
//			var pref = new Pref();
			
				var pref= Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
				pref.SetCharPref( "capability.principal.codebase.p13.granted" , "UniversalXPConnect UniversalBrowserWrite UniversalBrowserRead");
				pref.SetCharPref( "capability.principal.codebase.p13.id" , prev.url);			
				
			
			
				document.getElementById("frmMain").setAttribute("src", prev.url );
			}
		
		} else {

			if ( currentPage == "welcome" ) {
				backUrl = baseUrl + "Debugging.xul";
			}

			if ( currentPage == "license" ) {
				backUrl = baseUrl + "welcome.xul";
			}

			if ( currentPage == "featureselection" ) {
				nextUrl = baseUrl + "license.xul";
			}

			if ( backUrl != "" ) {
				document.getElementById("frmMain").setAttribute("src", backUrl  );
			}
		}
	}
}

function OnCancel() {

	window.close();

	gPackageManager.Finalize();
	try {
		gPackageManager = null;
	}
	catch( e ) {
	}
}


function nciAlert( mywnd  , text ) {

	var Pref = new Components.Constructor( "@mozilla.org/embedcomp/prompt-service;1" , "nsIPromptService" );
	var pref = new Pref();
	var ret;
	
	ret = pref.alert( mywnd ,  mywnd.parent.document.getElementById("main-window").getAttribute("title")  , text );
	
	return ret;
}


function SetProperty( name , value ) {

	var propMgr = Components.classes["@micromuse.com/NCIProperties;1"].getService(Components.interfaces.nsINCIProperties);				
	var prop = propMgr.GetProp( name );
	var pattern = new RegExp( prop.regexp );

	if ( pattern.test(value) ) {
		prop.value = value;
		return true;
	} else {
		return false;
	}
}

function GetProperty( name ) {

	var value = "";
	
	var propMgr = Components.classes["@micromuse.com/NCIProperties;1"].getService(Components.interfaces.nsINCIProperties);				
	
	try {
		value = propMgr.Get( name );
	}
	catch( e ) {
	}

	return value;
}



